!*********from Bob Simpsons' DCL PROGRAM**********

      subroutine sd2norm (strike,dip,xnorm)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!   Calculates the normal vector to a plane given its strike and dip.
!   Normal vector is given in the 1,2,3 (N,E,D) 
!   global coordinate system.
!
!   Convention assumed (even for dip=0):
!   If one stands and extends one's left hand sideways in the 
!   direction of strike, one is looking in the down-dip direction.  
!   Normal vector is cross-product of strike direction with dip 
!   direction, so it points downward for dips .ge.0 and .lt.90
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     Its subroutine:
!     - sd2locaxes
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      real x1axis(3), x2axis(3), x3axis(3), xnorm(3)

      call sd2locaxes (strike,dip,x1axis,x2axis,x3axis)

      do 100 i=1,3
 100  xnorm(i) = x3axis(i)

      return
      end


