!*********from Bob Simpsons' DCL PROGRAM**********

      subroutine locstrcmpnt (stress, strike, dip, strvecloc)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     Finds the stress vector (traction) on a plane
!     in the local coordinate system attached to the plane.
!
!       stress = symmetric stress tensor (6 components):
!        stress(1 or 2 or 3) = sig11 or sig22 or sig33
!        stress(4 or 5 or 6) = sig12 or sig13 or sig23
!
!       strike, dip = orientation of the plane.
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     Its subroutine:
!     - sd2norm
!     - stress2trac
!     - vecg2loc
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      real  stress(6), xperp(3), strvecglo(3), strvecloc(3)

        call sd2norm (strike, dip, xperp)
        call stress2trac (stress, xperp, strvecglo)
        call vecg2loc (strike,dip, strvecglo,strvecloc)

      return
      end


